function x = NewtonRaphson(f, x0, tol, maxit)

    x = x0;
    fx = f(x);
    
    dx = 1e-6;
    
    for it = 1:maxit
        
        if abs(fx) < tol
            break;
        end
        
        fpx = Derivative(f, x, dx);
        if abs(fpx) < tol
            break;
        end
        
        x = x - fx/fpx;
        fx = f(x);
        
    end
    
end

function dfdx = Derivative(f, x, dx)

    df = f(x + dx) - f(x - dx);
    dfdx = df/(2*dx);

end