import math

def secant(f, a, b, tol = 1e-10, maxit = 100):

    fa = f(a)
    if abs(fa) < tol:
        return a

    fb = f(b)
    if abs(fb) < tol:
        return b

    if fa*fb > 0:
        print("f(a) and f(b) must have different signs.")
        return None

    for _ in range(maxit):

        c = (a*fb - b*fa)/(fb - fa)
        fc = f(c)

        if abs(b - a) < tol:
            break
        
        if abs(fc) < tol:
            break

        if fa*fc > 0:
            a, fa = c, fc

        if fb*fc > 0:
            b, fb = c, fc

    return c

func = lambda x: x**2 - x - 1
a = 1
b = 5
x = secant(func, a, b, tol = 1e-20, maxit = 100)
print("Solution of 1st equation: x = {}, f(x) = {}".format(x, func(x)))

func2 = lambda x: x**2 - math.exp(-x) - 1
x2 = secant(func2, -1, 5, tol = 1e-6)
print("Solution of 2nd equation: x = {}, f(x) = {}".format(x2, func2(x2)))
